#ifndef _fencer_collision_h
#define _fencer_collision_h

#include "shape.h"
#include "physics_entity.h"
#include <stddef.h>

typedef uint32_t PhysicsMask;

typedef struct Collision {
    PhysicsEntity other;

    Vector point;
    Vector normal;

    Vector velocity;
    Vector penetration_vector;

    Vector edge_left;
    Vector edge_right;
} Collision;

typedef struct PhysicsQuery {
    Shape* shape;
    Transform* transform;
    PhysicsMask mask;
} PhysicsQuery;

extern Collision collision_invert(Collision src, PhysicsEntity new_other);
extern int collision_check(PhysicsEntity a, PhysicsEntity b, Collision* out_a, Collision* out_b);
extern int overlap_check(PhysicsQuery query, PhysicsEntity entity);

#endif // !_fencer_collision_h
